=== debian/changelog ===
ogre-1.12 (1.12.4+dfsg1-4) unstable; urgency=medium

  [ Simon Schmeisser ]
  * New upstream version (Closes: #943675)
    - Repack the source to meet DFSG
      (removed 'Samples' and 'SDK', git submodule init)
  * remove version from Vcs-Browser and Vcs-Git
  * d/patches:
    - removed patches included upstream
    - cmake-disable-samples.patch (Samples striped due to DFSG)
  * Bump Standards-Version to 4.4.1 (no changes needed)
  * blender2ogre is now a separate script, removed it from here
  * Switch to debhelper compat level 12
  * update d/gbp.conf, git-import-orig to import-orig
  * add copyright info for imgui
  * add python3 bindings (by Miriam Ruiz)
  * add build-dependency on dh-python
  * use MathJax from libjs-mathjax
  * fix rpath by using CMAKE_SKIP_RPATH
  * commented out external image in documentation due
    to potential privacy breach
  * added manpage for VRMLConverter
  * disable dh_dwz on libOgreMain.so.1.12.4 (elf_update failed)
  * remove pre/post-install scripts as they are outdated
  [ Olek Wojnar ]
  * Update copyright info

 -- Simon Schmeisser <s.schmeisser@gmx.net>  Sun, 05 Jan 2020 21:04:19 +0200

ogre-1.9 (1.9.0+dfsg1-12) unstable; urgency=medium

  * Bump Standards-Version to 4.2.1 (no changes needed)
  * d/control: Use https in Homepage URL
  * d/copyright: Use https in Format and Source URLs
  * d/watch:
    - Switch to version=4
    - Update URL to use the most recent repository location

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Sat, 20 Oct 2018 11:21:08 +0200

ogre-1.9 (1.9.0+dfsg1-11) unstable; urgency=medium

  * Bump Standards-Version to 4.1.4 (no changes needed)
  * Update Vcs-* URLs (salsa)
  * d/patches:
    - add riscv64-support.patch (Closes: #897663)

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Fri, 04 May 2018 01:09:29 +0200

ogre-1.9 (1.9.0+dfsg1-10) unstable; urgency=medium

  * Bump Standards-Version to 4.1.3 (no changes needed)
  * Switch to debhelper compat level 11
  * Set "Rules-Requires-Root: no" in d/control

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Sat, 20 Jan 2018 01:35:36 +0100

ogre-1.9 (1.9.0+dfsg1-9) unstable; urgency=medium

  * Bump shlibs version due to GCC v7 ABI change (Closes: #871296)

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Fri, 11 Aug 2017 17:59:53 +0200

ogre-1.9 (1.9.0+dfsg1-8) unstable; urgency=medium

  * Bump Standards-Version to 4.0.0 (no changes needed)
  * Switch to debhelper compat level v10
    - dh flags --parallel are not needed
  * Update Vcs-* URLs
  * Use automatic dbgsym packages, drop -dbg

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Tue, 01 Aug 2017 00:22:18 +0200

ogre-1.9 (1.9.0+dfsg1-7) unstable; urgency=medium

  * Change for reproducible builds: remove timestamp from documentation.
    Thanks Chris Lamb.  (Closes: #795462)
    - d/patches: reproducible-remove-documentation-timestamp.patch

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Sun, 01 Nov 2015 00:21:42 +0000

ogre-1.9 (1.9.0+dfsg1-6) unstable; urgency=medium

  * Release to unstable

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Thu, 13 Aug 2015 19:41:59 +0100

ogre-1.9 (1.9.0+dfsg1-5) experimental; urgency=medium

  * Bump Standards-Version to 3.9.6 (no changes needed)
  * Transition for GCC-5 with ABI change:
    - rename library package to *v5
    - in d/control, add Conflicts and Replaces on previous name of the
      library
  * Update Vcs-Browser link
  * In -dev package, add -dbg to Suggests
  * Address new lintian warning "embedded-javascript-library": add Depends
    on libjs-jquery in the -doc package, and create a symbolic link
    instead of install the local copy of the file "jquery.js"
  * Update the location of Docs/manual in copyright file and resolve minor
    issues (e.g. "dep5-copyright-license-name-not-unique" by renaming
    "License: other" to "License: otherN")

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Wed, 12 Aug 2015 15:54:49 +0100

ogre-1.9 (1.9.0+dfsg1-4) unstable; urgency=medium

  * Fix problem building GLES2 in big endian architectures (patch:
    fix-rendersystem-gles2-big-endian.patch)

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Sat, 20 Sep 2014 19:29:15 +0100

ogre-1.9 (1.9.0+dfsg1-3) unstable; urgency=medium

  * Enable support for GLES, thanks Bret Curtis
  * Create new patch support-arm64.patch to try to fix FTBFS on this port

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Fri, 12 Sep 2014 17:11:54 +0100

ogre-1.9 (1.9.0+dfsg1-2) unstable; urgency=medium

  * Change dependencies on Boost to the default versions (Closes: #749944)
  * Bump Standards-Version to 3.9.5 (no changes needed)

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Wed, 25 Jun 2014 21:12:05 +0100

ogre-1.9 (1.9.0+dfsg1-1) unstable; urgency=low

  * New upstream version
    - Repack the source to meet DFSG (simply removed all 'Samples', 'SDK' and
      '.hg*')
  * Remove dependency on GCC >= 4.8, it is causing problems in its current
    form and all architectures will be required soon to use 4.8 as default
    compiler if not done yet (Closes: #728521)

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Fri, 20 Dec 2013 00:50:55 +0000

ogre-1.9 (1.9.0~rc2+dfsg1-3) unstable; urgency=low

  * Make install rules also different for arch and indep

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Wed, 16 Oct 2013 15:31:37 +0100

ogre-1.9 (1.9.0~rc2+dfsg1-2) unstable; urgency=low

  * Separate building rules in arch-dependent and independent sections, to
    only build doc once (unneeded and very taxing, especially for less
    powerful machines).  At the moment is failing to build in all arches
    in buildds.

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Wed, 16 Oct 2013 12:06:09 +0100

ogre-1.9 (1.9.0~rc2+dfsg1-1) unstable; urgency=low

  * New upstream version
    - Repack the source to meet DFSG (simply removed all 'Samples', 'SDK' and
      '.hg*')
    - Support by upsteam of newer atomic functions, drop

